/* BF_in_BCB.cpp
 * Include this to make the BitFlow example programs compile in Borland C++ Builder 6
 *
 * Author: Jeremy Greene
 * BitFlow, Inc., 2010
 */

#pragma hdrstop

#include "BF_in_BCB.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)

#ifndef _MSC_VER
  
  #include <cstring.h>
  #include <stdarg.h>
  #include <iostream.h>
  
  /* scanf_s to scanf code modified from original at http://www.cplusplus.com/forum/beginner/2300/ */
  const char* scanf_validate ( const char* fmt, const char* file, long line )
  {
    const char* p = fmt;
    while (1)
    {
        p = strstr( p, "%s" );

        if (p == NULL) break;

        if ((p == fmt) || (*(p-1) != '%'))
        {
          cerr << "A \"%%s\ was used in " << file << ": line " << line << ".  This is not safe and should be replaced with a %%Xs, \
                   where X is a number indicating the maximum string length.\n";
          return "";
        }
    }
    return fmt;
  }

  const int scanf_s ( const char* fmt, ... )
  {
        va_list argptr;
        va_start (argptr, fmt);
        return vscanf( scanf_validate( fmt, __FILE__, __LINE__ ), argptr);
  }

  char* gets_s( char *strptr, const int strlen )
  {
        if ( std::cin.getline ( strptr, (streamsize)strlen ) == NULL )
                return NULL;
        else
                return strptr;
  }

#endif

